上一篇博客:LeetCode 200.岛屿数量(DFS、BFS)
写在前面:大家好!我是
ACfun
,我的昵称来自两个单词Accepted
和fun
。我是一个热爱ACM的蒟蒻。最近萌生了刷LeetCode的想法,所以我打算从LeetCode简单的题目开始做起,攻陷LeetCode。如果博客中有不足或者的错误的地方欢迎在评论区或者私信我指正,感谢大家的不吝赐教。我的唯一博客更新地址是:https://ac-fun.blog.csdn.net/。非常感谢大家的支持。一起加油,冲鸭!
用知识改变命运,用知识成就未来!加油 (ง •̀o•́)ง (ง •̀o•́)ง
原题链接:LeetCode 733. 图像渲染
题目信息
题目描述
有一幅以二维整数数组表示的图画,每一个整数表示该图画的像素值大小,数值在 0 到 65535 之间。
给你一个坐标 (sr, sc)
表示图像渲染开始的像素值(行 ,列)和一个新的颜色值 newColor
,让你重新上色这幅图像。
为了完成上色工作,从初始坐标开始,记录初始坐标的上下左右四个方向上像素值与初始坐标相同的相连像素点,接着再记录这四个方向上符合条件的像素点与他们对应四个方向上像素值与初始坐标相同的相连像素点,……,重复该过程。将所有有记录的像素点的颜色值改为新的颜色值。
最后返回经过上色渲染后的图像。
示例
输入:
image = [[1,1,1],[1,1,0],[1,0,1]]
sr = 1, sc = 1, newColor = 2
输出: [[2,2,2],[2,2,0],[2,0,1]]
解析:
在图像的正中间,(坐标(sr,sc)=(1,1)),
在路径上所有符合条件的像素点的颜色都被更改成2。
注意,右下角的像素没有更改为2,
因为它不是在上下左右四个方向上与初始点相连的像素点。
注意
image
和image[0]
的长度在范围[1, 50]
内。- 给出的初始点将满足
0 <= sr < image.length
和0 <= sc < image[0].length
。 image[i][j]
和newColor
表示的颜色值在范围[0, 65535]
内。
题解
DFS解法
解题思路
本题与上一篇博客的题目一样也是经典的 Flood fill 算法(洪水填充算法)
,有关该算法的详细解释请看上一篇博客 LeetCode 200.岛屿数量(DFS、BFS)。思路也是相同的,即我们从初始坐标开始进行 深度优先搜索
如果初始点的四周有符合条件的点就继续以该点为起点继续进行 dfs搜索
当搜索完成后返回 image
即可。按照这个思路写我们还需要开一个标记数组,将渲染过的图像标记为 -1
,防止重复遍历相同的点而出现死循环的情况。
这里补充下有关类似题目的一些 小技巧
。首先我们进行向四个方向遍历的时候我们可以使用一个 for循环来代替四个dfs语句
。虽然两段代码的功能是一样的,但是在方向多的时候第二段代码更加简练一些。比如当我们需要遍历 8 个方向的时候,我们使用 for循环
还是这些代码量,但是不用 for循环
就需要我们写 8 条这样的 dfs
语句,让我们的代码看起来会有点繁琐冗余。
先看一下不使用for循环的代码:
dfs(x - 1, y, newColor); // 上
dfs(x + 1, y, newColor); // 下
dfs(x, y - 1, newColor); // 左
dfs(x, y + 1, newColor); // 右
下面是使用for循环的代码
int dx[4] = {
1, 0, -1, 0}, dy[4] = {
0, 1, 0, -1};
for (int i = 0; i < 4; i++) {
int x1 = x + dx[i], y1 = y + dy[i];
if (inmap(x1, y1) && flag[x1][y1] != -1 && img[x1][y1] == c) {
dfs(x1, y1, color);
}
}
第二点就是我们可以定义一个全局变量来保存地图,这样在dfs传参的时候我们就可以少传一个地图参数。
解题代码
class Solution {
public:
vector<vector<int>> img, flag;
int dx[4] = {
1, 0, -1, 0}, dy[4] = {
0, 1, 0, -1};
vector<vector<int>> floodFill(vector<vector<int>>& image, int sr, int sc, int newColor) {
img = flag = image;
dfs(sr, sc, newColor);
return img;
}
void dfs(int x, int y, int color) {
int c = img[x][y];
img[x][y] = color;
flag[x][y] = -1;
for (int i = 0; i < 4; i++) {
int x1 = x + dx[i], y1 = y + dy[i];
if (inmap(x1, y1) && flag[x1][y1] != -1 && img[x1][y1] == c) {
dfs(x1, y1, color);
}
}
}
bool inmap(int x, int y) {
return x >= 0 && x < img.size() && y >= 0 && y < img[0].size();
}
};
时间复杂度
时间复杂度:O(n×m)
,其中 n 和 m 分别是二维数组的行数和列数。最坏情况下需要遍历所有的方格一次。
提交结果
BFS解法
解题代码
class Solution {
public:
vector<vector<int>> img, flag;
int dx[4] = {
1, 0, -1, 0}, dy[4] = {
0, 1, 0, -1};
vector<vector<int>> floodFill(vector<vector<int>>& image, int sr, int sc, int newColor) {
img = flag = image;
bfs(sr, sc, newColor);
return img;
}
void bfs(int x, int y, int color) {
queue<pair<int, int>> q;
q.push({
x, y});
int c = img[x][y];
img[x][y] = color;
flag[x][y] = -1;
while(!q.empty()) {
pair<int, int> xy = q.front();
q.pop();
for (int i = 0; i < 4; i++) {
int x1 = xy.first + dx[i], y1 = xy.second + dy[i];
if (inmap(x1, y1) && flag[x1][y1] != -1 && img[x1][y1] == c) {
q.push({
x1, y1});
img[x1][y1] = color;
flag[x1][y1] = -1;
}
}
}
}
bool inmap(int x, int y) {
return x >= 0 && x < img.size() && y >= 0 && y < img[0].size();
}
};
时间复杂度
O(n×m)
,其中 n 和 m 分别是二维数组的行数和列数。最坏情况下需要遍历所有的方格一次。
提交结果
未完待续,持续更新中……
转载:https://blog.csdn.net/qq_41575507/article/details/108354981